#pragma once
#define _WINSOCK_DEPRECATED_NO_WARNINGS
#include <iostream> 
#include <winsock2.h> 
#include <ws2tcpip.h> 
#include <iphlpapi.h>  //  SendARP ͷļ
#include<vector>
#include <QString>
#include <chrono>
#include <thread>
#include <future>
#include<queue>
using namespace std;
#pragma comment(lib, "Ws2_32.lib") 
#pragma comment(lib, "Iphlpapi.lib")  //  Iphlpapi.lib 
//IP ͷ
typedef struct
{
	unsigned char hdr_len : 4; //4 λͷ
	unsigned char version : 4; //4 λ汾
	unsigned char tos; //8 λ
	unsigned short total_len; //16 λܳ
	unsigned short identifier; //16 λʶ
	unsigned short frag_and_flags; //3 λ־ 13 λƬƫ
	unsigned char ttl; //8 λʱ
	unsigned char protocol; //8 λϲЭ
	unsigned short checksum; //16 λУ
	unsigned long sourceIP; //32 λԴ IP ַ
	unsigned long destIP; //32 λĿ IP ַ
} IP_HEADER;

//ICMP ͷ
typedef struct
{
	BYTE type; //8 λֶ
	BYTE code; //8 λֶ
	USHORT cksum; //16 λУ
	USHORT id; //16 λʶ
	USHORT seq; //16 λк
} ICMP_HEADER;

//Ľṹ
typedef struct
{
	USHORT usSeqNo; //к
	DWORD dwRoundTripTime; //ʱ
	in_addr dwIPaddr; //رĵ IP ַ
}DECODE_RESULT;

//Уͺ
USHORT checksum(USHORT* pBuf, int iSize)
{
	unsigned long cksum = 0;
	while (iSize > 1)
	{
		cksum += *pBuf++;
		iSize -= sizeof(USHORT);
	}
	if (iSize)
	{
		cksum += *(UCHAR*)pBuf;
	}
	cksum = (cksum >> 16) + (cksum & 0xffff);
	cksum += (cksum >> 16);
	return (USHORT)(~cksum);
}
//ݰн
BOOL DecodeIcmpResponse(char* pBuf, int iPacketSize, DECODE_RESULT& DecodeResult, BYTE
	ICMP_ECHO_REPLY, BYTE ICMP_TIMEOUT)
{
	//ݱСĺϷ
	IP_HEADER* pIpHdr = (IP_HEADER*)pBuf;
	int iIpHdrLen = pIpHdr->hdr_len * 4;
	if (iPacketSize < (int)(iIpHdrLen + sizeof(ICMP_HEADER)))
		return FALSE;
	// ICMP ȡ ID ֶκкֶ
	ICMP_HEADER* pIcmpHdr = (ICMP_HEADER*)(pBuf + iIpHdrLen);
	USHORT usID, usSquNo;
	if (pIcmpHdr->type == ICMP_ECHO_REPLY) //ICMP Ӧ
	{
		usID = pIcmpHdr->id; // ID 
		usSquNo = pIcmpHdr->seq; //к
	}
	else if (pIcmpHdr->type == ICMP_TIMEOUT)//ICMP ʱ
	{
		char* pInnerIpHdr = pBuf + iIpHdrLen + sizeof(ICMP_HEADER); //غе IP ͷ
		int iInnerIPHdrLen = ((IP_HEADER*)pInnerIpHdr)->hdr_len * 4; //غе IP ͷ
		ICMP_HEADER* pInnerIcmpHdr = (ICMP_HEADER*)(pInnerIpHdr + iInnerIPHdrLen);//غе ICMP ͷ
		usID = pInnerIcmpHdr->id; // ID 
		usSquNo = pInnerIcmpHdr->seq; //к
	}
	else
	{
		return false;
	}
	// ID кȷյڴݱ
	if (usID != (USHORT)GetCurrentProcessId() || usSquNo != DecodeResult.usSeqNo)
	{
		return false;
	}
	//¼ IP ַʱ
	DecodeResult.dwIPaddr.s_addr = pIpHdr->sourceIP;
	DecodeResult.dwRoundTripTime = GetTickCount() - DecodeResult.dwRoundTripTime;
	//ȷյ ICMP ݱ
	if (pIcmpHdr->type == ICMP_ECHO_REPLY || pIcmpHdr->type == ICMP_TIMEOUT)
	{
		//ʱϢ
		/*if (DecodeResult.dwRoundTripTime)
			cout << " " << DecodeResult.dwRoundTripTime << "ms" << flush;
		else
			cout << " " << "<1ms" << flush;*/
	}
	return true;
}

std::string GetMacAddress(const std::string& ipAddress) {
	ULONG macAddr[2];
	ULONG phyAddrLen = 6;  // MAC ַ

	// ַʽ IP ַתΪ ULONG 
	ULONG destIP = inet_addr(ipAddress.c_str());

	if (SendARP(destIP, 0, macAddr, &phyAddrLen) == NO_ERROR) {
		// ʹ std::vector 洢 MAC ַֽ
		std::vector<unsigned char> macBytes(phyAddrLen);

		//  ULONG ͵ MAC ַתΪֽ
		for (size_t i = 0; i < phyAddrLen; ++i) {
			macBytes[i] = static_cast<unsigned char>((macAddr[i >> 2] >> ((i & 3) << 3)) & 0xFF);
		}

		// ʽ MAC ַַ
		char macAddress[18];
		snprintf(macAddress, sizeof(macAddress), "%02X:%02X:%02X:%02X:%02X:%02X",
			macBytes[0], macBytes[1], macBytes[2], macBytes[3], macBytes[4], macBytes[5]);

		return std::string(macAddress);
	}
	else {
		return "Failed to retrieve MAC address";
	}
}


std::string getHostNameAsync(const sockaddr_in& from) {
	char hostName[NI_MAXHOST];

	if (getnameinfo((sockaddr*)&from, sizeof(from), hostName, NI_MAXHOST, NULL, 0, 0) == 0) {
		return std::string(hostName);
	}
	else {
		return "";
	}
	
}

vector<QString> ip_function(QString ip_address, int overtime, int DEF_MAX_HOP)
{
	// ȡʼʱ
	auto start = std::chrono::high_resolution_clock::now();
	//vector<std::vector<QString>> result;
	vector<QString> one_of_result;
	//ʼ Windows sockets 绷}
	WSADATA wsa;
	if (WSAStartup(MAKEWORD(2, 2), &wsa) != 0) {
		std::cerr << "Failed to initialize Winsock" << std::endl;
		return one_of_result;
	}

	
	u_long ulDestIP = inet_addr(ip_address.toStdString().c_str());
	//תɹʱ
	if (ulDestIP == INADDR_NONE)
	{
		hostent* pHostent = gethostbyname(ip_address.toStdString().c_str());
		if (pHostent)
		{
			ulDestIP = (*(in_addr*)pHostent->h_addr).s_addr;
		}
		else
		{
			//cout << " IP ַЧ!" << endl;
			WSACleanup();
			return one_of_result;
		}
	}

	//Ŀض socket ַ
	sockaddr_in destSockAddr;
	ZeroMemory(&destSockAddr, sizeof(sockaddr_in));
	destSockAddr.sin_family = AF_INET;
	destSockAddr.sin_addr.s_addr = ulDestIP;
	//ԭʼ׽
	SOCKET sockRaw = WSASocket(AF_INET, SOCK_RAW, IPPROTO_ICMP, NULL, 0,
		WSA_FLAG_OVERLAPPED);
	//ʱʱ
	int iTimeout = overtime;
	//ճʱ
	setsockopt(sockRaw, SOL_SOCKET, SO_RCVTIMEO, (char*)&iTimeout, sizeof(iTimeout));
	//ͳʱ
	setsockopt(sockRaw, SOL_SOCKET, SO_SNDTIMEO, (char*)&iTimeout, sizeof(iTimeout));
	// ICMP Ϣ TTL ˳ͱ
	//ICMP ֶ
	const BYTE ICMP_ECHO_REQUEST = 8; //
	const BYTE ICMP_ECHO_REPLY = 0; //Ӧ
	const BYTE ICMP_TIMEOUT = 11; //䳬ʱ
	//
	const int DEF_ICMP_DATA_SIZE = 32; //ICMP Ĭֶγ
	const int MAX_ICMP_PACKET_SIZE = 1024;//ICMP 󳤶ȣͷ
	const DWORD DEF_ICMP_TIMEOUT = overtime; //Ӧʱʱ
	//const int DEF_MAX_HOP = 30; //վ
	// ICMP ÿηʱֶ
	char IcmpSendBuf[sizeof(ICMP_HEADER) + DEF_ICMP_DATA_SIZE];//ͻ
	memset(IcmpSendBuf, 0, sizeof(IcmpSendBuf)); //ʼͻ
	char IcmpRecvBuf[MAX_ICMP_PACKET_SIZE]; //ջ
	memset(IcmpRecvBuf, 0, sizeof(IcmpRecvBuf)); //ʼջ
	ICMP_HEADER* pIcmpHeader = (ICMP_HEADER*)IcmpSendBuf;
	pIcmpHeader->type = ICMP_ECHO_REQUEST; //Ϊ
	pIcmpHeader->code = 0; //ֶΪ 0 
	pIcmpHeader->id = (USHORT)GetCurrentProcessId(); //ID ֶΪǰ̺
	memset(IcmpSendBuf + sizeof(ICMP_HEADER), 'E', DEF_ICMP_DATA_SIZE);//ֶ
	USHORT usSeqNo = 0; //ICMP к
	int iTTL = 1; //TTL ʼֵΪ 1 
	BOOL bReachDestHost = FALSE; //ѭ˳־
	int iMaxHot = DEF_MAX_HOP; //ѭ
	DECODE_RESULT DecodeResult; //ݸĽ뺯Ľṹ
	QString macAddress;//ַ
	int iReadDataLen = 0; //ݳ
	QString host_name;//
	sockaddr_in from; //Զ socket ַ

	while (!bReachDestHost && iMaxHot--)
	{
		// IP ͷ TTL ֶ
		setsockopt(sockRaw, IPPROTO_IP, IP_TTL, (char*)&iTTL, sizeof(iTTL));

		// ICMP ÿηͱ仯ֶ
		((ICMP_HEADER*)IcmpSendBuf)->cksum = 0; //УΪ 0 
		((ICMP_HEADER*)IcmpSendBuf)->seq = htons(usSeqNo++); //к
		((ICMP_HEADER*)IcmpSendBuf)->cksum = checksum((USHORT*)IcmpSendBuf,
			sizeof(ICMP_HEADER) + DEF_ICMP_DATA_SIZE); //У
		//¼кź͵ǰʱ
		DecodeResult.usSeqNo = ((ICMP_HEADER*)IcmpSendBuf)->seq; //ǰ
		DecodeResult.dwRoundTripTime = GetTickCount64(); //ǰʱ
		// TCP Ϣ
		sendto(sockRaw, IcmpSendBuf, sizeof(IcmpSendBuf), 0, (sockaddr*)&destSockAddr, sizeof(destSockAddr));
		// ICMP Ĳн
		int iFromLen = sizeof(from); //ַṹС
		while (1)
		{
			
			int iFromLen = sizeof(from);
			// Ŀַ
			iReadDataLen = recvfrom(sockRaw, IcmpRecvBuf, MAX_ICMP_PACKET_SIZE, 0, (sockaddr*)&from, &iFromLen);

			if (iReadDataLen != SOCKET_ERROR)//ݵ
			{
				//ݰн
				if (DecodeIcmpResponse(IcmpRecvBuf, iReadDataLen, DecodeResult, ICMP_ECHO_REPLY, ICMP_TIMEOUT))
				{
					//Ŀĵأ˳ѭ
					if (DecodeResult.dwIPaddr.s_addr == destSockAddr.sin_addr.s_addr) 	bReachDestHost = true;
					// IP ַ
					cout << '\t' << inet_ntoa(DecodeResult.dwIPaddr) << endl;
				}
				
				break;
			}
			else if (WSAGetLastError() == WSAETIMEDOUT) //ճʱ*
			{
				//cout << " *" << '\t' << "Request timed out." << endl;
				break;
			}
			else
			{
				break;
			}
		}

		iTTL++; // TTL ֵ
	}

	
	one_of_result.push_back(ip_address);
	if (iTTL != DEF_MAX_HOP + 1)
	{
		//ȡ
		// ȡĿַַ
		macAddress = QString::fromStdString(GetMacAddress(ip_address.toStdString()));
		
		host_name = QString::fromStdString(getHostNameAsync(from));
		one_of_result.push_back(macAddress);
		one_of_result.push_back(host_name);
		one_of_result.push_back("");
		// ʱ
		// ȡʱ
		auto end = std::chrono::high_resolution_clock::now();
		auto duration = std::chrono::duration_cast<std::chrono::milliseconds>(end - start);
		one_of_result.push_back(QString::number(duration.count()));
	}
	else{
		one_of_result.push_back("-");
		one_of_result.push_back(host_name);
		one_of_result.push_back("");
		one_of_result.push_back("-");
	}

	// ں˳ǰȷ closesocket ر׽
	closesocket(sockRaw);
	
	
	/*result.push_back(one_of_result);
	one_of_result.clear();*/
	

	return one_of_result;
}