#ifdef WIN32  
#pragma execution_character_set("utf-8")  
#endif
#include "tracert.h"
#include <QMessageBox>
#include"function.h"
tracert::tracert(QWidget *parent)
    : QMainWindow(parent)
{
    ui.setupUi(this);
    
    connect(ui.end, &QPushButton::clicked, this, &tracert::on_end_button_clicked);//ȡťܺ
    connect(ui.start, &QPushButton::clicked, this, &tracert::on_start_button_clicked);
    connect(ui.simplify, &QPushButton::clicked, this, &tracert::on_simplify_button_clicked);
}

tracert::~tracert()
{}

bool tracert::check_the_data(QString& ip, QString& ip_begin, QString& ip_end, QString& overtime, QString& threads)//ǷϷ
{
    
    QString ip_1 = ui.ip_1->text();
    if (ip_1.isEmpty()) return false;
    for (auto& iterator : ip_1)
    {
        if (!iterator.isDigit())//֣ǿ,ǷǷ
        {
            return false;
        }
    }

    QString ip_2 = ui.ip_2->text();
    if (ip_2.isEmpty()) return false;
    for (auto& iterator : ip_2)
    {
        if (!iterator.isDigit())//֣ǷǷ
        {
            return false;
        }
    }

    QString ip_3 = ui.ip_3->text();
    if (ip_3.isEmpty()) return false;
    for (auto& iterator : ip_3)
    {
        if (!iterator.isDigit())//֣ǷǷ
        {
            return false;
        }
    }

    ip = ip_1 + "." + ip_2 + "." + ip_3;

    ip_begin = ui.ip_begin->text();
    if (ip_begin.isEmpty()) return false;
    for (auto& iterator : ip_begin)
    {
        if (!iterator.isDigit())//֣ǷǷ
        {
            return false;
        }
    }

    ip_end = ui.ip_end->text();
    if (ip_end.isEmpty()) return false;
    for (auto& iterator : ip_end)
    {
        if (!iterator.isDigit())//֣ǷǷ
        {
            return false;
        }
    }

    if (ip_begin.toInt() > ip_end.toInt())
    {
        return false;
    }
    else
    {
        ui.tableWidget->setRowCount(ip_end.toInt() - ip_begin.toInt() + 1);
        QCoreApplication::processEvents();
    }

    overtime = ui.overtime->text();
    if (overtime.isEmpty()) return false;
    for (auto& iterator : overtime)
    {
        if (!iterator.isDigit())//֣ǷǷ
        {
            return false;
        }
    }

    if (overtime.toInt() <= 0)
    {
        return false;
    }
    
    threads = ui.threads->text();
    if (threads.isEmpty()) return false;
    for (auto& iterator : threads)
    {
        if (!iterator.isDigit())//֣ǷǷ
        {
            return false;
        }
    }

    return true;
}



void tracert::on_end_button_clicked()
{
    // endť¼
    QCoreApplication::quit();
}

void tracert::on_start_button_clicked() {
    // startť¼
    QString ip, ip_begin, ip_end, overtime, threads;
    //ȼǷϷ
    if (check_the_data(ip, ip_begin, ip_end, overtime, threads))//Ϸ
    {
        ui.tableWidget->clear();
        // ȡǰʱ̵ıʱ
        auto start = std::chrono::system_clock::now();
        int response = 0;
        std::time_t startTime = std::chrono::system_clock::to_time_t(start);

        // ʹ localtime תΪ tm ṹ
        std::tm tmStartTime = *std::localtime(&startTime);
        string start_time = std::to_string(tmStartTime.tm_hour) + ":" + std::to_string(tmStartTime.tm_min) + ":" + std::to_string(tmStartTime.tm_sec);

        //ipvector<QString>
        std::vector<QString> ip_address;
        std::vector< QString > result;
        int row = 0, col;
        for (int i = ip_begin.toInt(); i <= ip_end.toInt(); i++)
        {
            ip_address.push_back(ip + "." + QString::number(i));
        }
        
        int num = 0;
        for (auto& iterator: ip_address) {
            result = ip_function(iterator, overtime.toInt(), 2);//ȡ
            //
            auto iterator_result = result.begin();//ȡǰ

            for (row; row < ui.tableWidget->rowCount(); ) {
                for (col = 0; iterator_result != result.end() && col < ui.tableWidget->columnCount(); ++col, iterator_result++) {
                    if (*iterator_result=="")
                    {
                        response++;
                    }
                    QString data = QString("%1").arg(*iterator_result);
                    QTableWidgetItem* item = new QTableWidgetItem(data);
                    ui.tableWidget->setItem(row, col, item);
                    
                    
                }
                //
               
                ++row;
                break;
            }
            //ui.tableWidget->update();
            QCoreApplication::processEvents();
            num++;
        }
        //ui.tableWidget->repaint();

        auto end = std::chrono::system_clock::now();
        std::time_t endTime = std::chrono::system_clock::to_time_t(end);

        // ʹ localtime תΪ tm ṹ
        std::tm tmEndTime = *std::localtime(&endTime);
        string end_time = std::to_string(tmEndTime.tm_hour) + ":" + std::to_string(tmEndTime.tm_min) + ":" + std::to_string(tmEndTime.tm_sec);

        auto duration = std::chrono::duration_cast<std::chrono::milliseconds>(end - start);//ʱ
        ui.time_spent->setText(QString::fromStdString(std::to_string(duration.count())));
        ui.Number_of_responses->setText(QString::fromStdString(std::to_string(response)));
        ui.start_time->setText(QString::fromStdString(start_time));
        ui.end_time->setText(QString::fromStdString(end_time));
    }
    else {
        // һϢ
        QMessageBox messageBox;

        // öԻ
        messageBox.setWindowTitle((""));

        // öԻı
        messageBox.setText(("ϢǷ"));

        // ðť
        messageBox.addButton(QMessageBox::Ok);

        // ʾԻ򣬲ȴûӦ
        messageBox.exec();
    }

    return;
}

void tracert::on_simplify_button_clicked()
{
    int rowCount = ui.tableWidget->rowCount();  // ȡʼ
    for (int row = rowCount - 1; row >= 0; --row) {
        QTableWidgetItem* item = ui.tableWidget->item(row, 3); // 4
        if (item && item->text() != "") {
            ui.tableWidget->removeRow(row);
        }
    }
}
